//
// NB! This is a file generated from the .4Dino file, changes will be lost
//     the next time the .4Dino file is built
//
// Define LOG_MESSAGES to a serial port to send SPE errors messages to. Do not use the same Serial port as SPE
//#define LOG_MESSAGES Serial

#define RESETLINE     30

#define DisplaySerial Serial1

#include "Picaso_Serial_4DLib.h"
#include "Picaso_Const4D.h"
Picaso_Serial_4DLib Display(&DisplaySerial);


#include <SoftwareSerial.h>
#include "_4Duino_Demo_APIConst.h"

#define ESPRESET 17
#define ESPserial SerialS
#define NAME "YAAT"      //name of wireless access point to connect to
#define PASS "66204146630408"   //wifi password
#define dConnectionType "TCP"
#define dDomain "weathers.co"
#define dConnectionPort "80"

#define FONT_SIZE 3

//#define DebugESPmsgs //Comment if you want to hide printing ESP response to ATcommands

SoftwareSerial SerialS(8, 9) ;

char debug;
String httpresponse ;     // response from a http request
String IP ; // device IP

// routine to handle Serial errors
void mycallback(int ErrCode, unsigned char Errorbyte)
{
  // Pin 13 has an LED connected on most Arduino boards. Just give it a name
#define led 13
  while (1)
  {
    digitalWrite(led, HIGH);   // turn the LED on (HIGH is the voltage level)
    delay(200);                // wait for a second
    digitalWrite(led, LOW);    // turn the LED off by making the voltage LOW
    delay(200);                // wait for a second
  }
}
// end of routine to handle Serial errors


bool ConfigESP8266()
{
  String cmd = F("AT+CWJAP=\"");  // use Flash constants to avoid using up all RAM
  cmd += NAME;
  cmd += F("\",\"");              // use Flash constants to avoid using up all RAM
  cmd += PASS;
  cmd += F("\"\r\n");             // use Flash constants to avoid using up all RAM

  String res;
 if(debug == 0)
 {
  Display.print("Connecting");//85,5,5
  //sendCommand("AT+RST\r\n", 1000); // reset module
  Display.print("#");
  sendCommand(cmd, 1000); //**** CHANGE SSID and PASSWORD ACCORDING TO YOUR NETWORK ******//
  Display.print("#");//We need to wait 5Sec after CWJAP command
  delay(1000);
  Display.print("#");
  delay(1000);
  Display.print("#");
  delay(1000);
  Display.print("#");
  delay(1000);
  Display.print("#");
  sendCommand("AT+CIPMODE=0\r\n", 1000); // configure for multiple connections
  Display.print("#");
  sendCommand("AT+CIPMUX=0\r\n", 1000); // turn on server on port 1337
  Display.print("#");
  }
  else
  {
     sendCommand(cmd, 5000);
     sendCommand("AT+CIPMODE=0\r\n", 1000);
     sendCommand("AT+CIPMUX=0\r\n", 1000);
  }
  IP = sendCommand("AT+CIFSR\r\n", 1000); // get ip address

  delay(4000);
  Display.gfx_Cls(); // clear the screen

  //Display.print(IP);

  if (IP.length() <= 25)
  {
    if(debug==0)
    {
      Display.print("Wifi connection failed\n");
      Display.print("Check WiFi settings, and restart 4Duino\n");
    }
    //while (1); // crash here
    loop();
  }
  else
  {
    IP = IP.substring(25, 38); // Get the IP part from the command response
    if(debug==1)
    Display.print("Connectted to Wifi \n") ;

    cmd = "AT+CIPSTART=\"";  // use Flash constants to avoid using up all RAM
    cmd += dConnectionType;
    cmd += "\",\"";              // use Flash constants to avoid using up all RAM
    cmd += dDomain;
    cmd += "\",";             // use Flash constants to avoid using up all RAM
    cmd += dConnectionPort;
    cmd += "\r\n";
    String res;
    res=sendCommand(cmd,2000) ;
    if(res.indexOf("CONNECT")!=-1)
    {
    if(debug==0)
     Display.println("Connected to");

    }
     else
     {
        if(debug==0)
        Display.println("Not Connected to");
     }
    Display.println(dDomain);

    return 1;
  }
}

String sendCommand(String command, const int timeout)
{
  String response = "";

  ESPserial.print(command); // send the read character to the esp8266

  long int time = millis();

  while ((time + timeout) > millis())
  {
    while (ESPserial.available()) // Read the response from ESP
    {
      char c = ESPserial.read();
      response += c;
    }
  }
  if(debug==1)
  Display.print(response);

  return response;

}

void sendData(String command, const int timeout)
{

  int dataSize = command.length();
  char data[dataSize];
  command.toCharArray(data, dataSize);
  httpresponse=" ";
  ESPserial.write(data, dataSize); // send the read character to the esp8266
  Display.txt_FGcolour(BLACK);
  long int time = millis();

  while ( (time + timeout) > millis())
  {

    while (ESPserial.available()) // Read the response from ESP
    {
      char c = ESPserial.read();
      //Display.print(c);
      httpresponse += c;
    }

  }


  Display.println(httpresponse);
  //Display.print(response);
}

void SendToMod(String content)
{
  String cipSend = "AT+CIPSEND=";
  cipSend += content.length()+1;
  cipSend += "\r\n";
  content += " "; // There is a bug in this code: the last character of "content" is not sent, I cheated by adding this extra space
  String response = "";

  ESPserial.print(cipSend); // send the read character to the esp8266
  delay(20);
  sendData(content, 3000);
  /*
  String res = sendCommand(cipSend,1000);
  if(res.indexOf('>')!=-1)
    sendData(content, 1000);
  else
   Display.print("\r\nERROR");
   */
}


word hndl ;
word x, y ;

void setup()
{
  pinMode(RESETLINE, OUTPUT);       // Display reset pin
digitalWrite(RESETLINE, 1);       // Reset Display, using shield
  delay(100);                       // wait for it to be recognised
digitalWrite(RESETLINE, 0);       // Release Display Reset, using shield

// Uncomment when using ESP8266
   pinMode(ESPRESET, OUTPUT);        // ESP reset pin
  digitalWrite(ESPRESET, 1);        // Reset ESP
  delay(100);                       // wait for it t
  digitalWrite(ESPRESET, 0);        // Release ESP reset
  delay(3000) ;                     // give display time to startup

  // now start display as Serial lines should have 'stabilised'
  DisplaySerial.begin(200000) ;     // Hardware serial to Display, same as SPE on display is set to
  Display.TimeLimit4D = 5000 ;      // 5 second timeout on all commands
  Display.Callback4D = mycallback ;

//hFontn = Display.file_LoadImageControl("NoName1.dnn", "NoName1.gnn", 1); // Open handle to access uSD fonts, uncomment if required and change nn to font number
//hstrings = Display.file_Open("_4DUIN~1.txf", 'r') ;                            // Open handle to access uSD strings, uncomment if required
Display.gfx_ScreenMode(PORTRAIT) ; // change manually if orientation change
  if (!(Display.file_Mount()))
  {
    while(!(Display.file_Mount()))
    {
      Display.putstr("Check if the SD card inserted and reset!");
      delay(200);
      Display.gfx_Cls();
      delay(200);
    }
  }
  Display.gfx_BGcolour(WHITE) ;
  Display.txt_BGcolour(WHITE) ;
  Display.txt_FGcolour(BLUE) ;
  Display.gfx_Cls() ;
  hndl = Display.file_LoadImageControl("_4DUIN~1.dat", "_4DUIN~1.gci", 1);
  Display.img_Show(hndl,iImage1) ;  // Image1
  Display.img_SetWord(hndl, i4Dbutton2, IMAGE_INDEX, 0); // 4Dbutton1 where state is 0 for up and 1 for down
  Display.img_Show(hndl,i4Dbutton2) ;  // 4Dbutton2
  Display.gfx_MoveTo(5, 200);
  Display.putstr("Start");
  Display.img_SetWord(hndl, i4Dbutton1, IMAGE_INDEX, 0); // 4Dbutton1 where state is 0 for up and 1 for down
  Display.img_Show(hndl,i4Dbutton1) ;  // 4Dbutton1
  Display.gfx_MoveTo(5, 264);
  Display.putstr("Debug");
  Display.touch_Set(TOUCH_ENABLE);

  int LOOP=1;
  debug=0;
while(LOOP)
{
  byte state;
  state = Display.touch_Get(TOUCH_STATUS);               // get touchscreen status
  //-----------------------------------------------------------------------------------------
  if((state == TOUCH_PRESSED) || (state == TOUCH_MOVING))                       // if there's a press, or it's moving
  {
    x = Display.touch_Get(TOUCH_GETX);
    y = Display.touch_Get(TOUCH_GETY);
  }

  //-----------------------------------------------------------------------------------------
  if(state == TOUCH_RELEASED)                      // if there's a release
  {
    if ((x >= 24) && (x <= 72) && (y >= 180) && (y <= 228))
    {
      Display.img_SetWord(hndl, i4Dbutton2, IMAGE_INDEX, 1); // 4Dbutton1 where state is 0 for up and 1 for down
      Display.img_Show(hndl,i4Dbutton2) ;  // 4Dbutton1
      LOOP=0;
    }
    else if ((x >= 24) && (x <= 72) && (y >= 248) && (y <= 292))
    {
      Display.img_SetWord(hndl, i4Dbutton1, IMAGE_INDEX, 1); // 4Dbutton1 where state is 0 for up and 1 for down
      Display.img_Show(hndl,i4Dbutton1) ;  // 4Dbutton
      debug = 1;
    }
  }
}
  delay(1000);
  Display.gfx_Cls(); // clear the screen
  pinMode(ESPRESET, OUTPUT);        // ESP reset pin
  digitalWrite(ESPRESET, 1);        // Reset ESP
  delay(100);
  digitalWrite(ESPRESET, 0);        // Release ESP reset
  delay(3000) ;                     // give display time to startup

  // now start display as Serial lines should have 'stabilised'
  DisplaySerial.begin(200000) ;     // Hardware serial to Display, same as SPE on display is set to
  Display.TimeLimit4D = 5000 ;      // 5 second timeout on all commands
  Display.Callback4D = mycallback ;

  ESPserial.begin(115200) ;         // assume esp set to 115200 baud, it's default setting
                                    // what we need to do is attempt to flip it to 19200
                                    // the maximum baud rate at which software serial actually works
                                    // if we run a program without resetting the ESP it will already be 19200
                                    // and hence the next command will not be understood or executed

  ESPserial.println("AT+UART_CUR=19200,8,1,0,0\r\n") ;
  ESPserial.end() ;
  delay(10) ;                         // Necessary to allow for baud rate changes
  ESPserial.begin(19200) ;            // start again at a resonable baud rate

  Display.gfx_ScreenMode(PORTRAIT) ; // change manually if orientation change
  Display.txt_FGcolour(BLUE) ;
  Display.txt_FontID(FONT1) ;         // largest internal font
  ConfigESP8266();
  Display.txt_FGcolour(RED) ;

  String httpHeader;
  httpHeader = "GET ";
  httpHeader += "/api.php?city=New+York HTTP/1.1\r\n";
  httpHeader += "Host: weathers.co\r\n";
  httpHeader += "Connection: close\r\n\r\n";

  delay(4000);
  Display.gfx_Cls(); // clear the screen
  SendToMod(httpHeader);
   /*
  Display.print(httpresponse.indexOf('{'));
  Display.print(httpresponse.indexOf('}'));
  for(int i=httpresponse.indexOf('{'); i<httpresponse.indexOf('}'); i++)
  {
    if(httpresponse[i]==',')
      Display.print('\r\n');
    else
    Display.print(httpresponse[i]);
  }
    */
  Display.gfx_Button(1, 8, 296, WHITESMOKE, BLACK, FONT1, 1, 1, "Restart") ; // Button1 Width=62 Height=17
}

void loop()
{
 byte state ;
  state = Display.touch_Get(TOUCH_STATUS);               // get touchscreen status
  //-----------------------------------------------------------------------------------------
  if((state == TOUCH_PRESSED) || (state == TOUCH_MOVING))                       // if there's a press, or it's moving
  {
    x = Display.touch_Get(TOUCH_GETX);
    y = Display.touch_Get(TOUCH_GETY);
  }

  //-----------------------------------------------------------------------------------------
  if(state == TOUCH_RELEASED)                      // if there's a release
  {
    if ((x >= 8) && (x <= 70) && (y >= 296) && (y <= 313))
    {
      setup();
    }
  }
}

